#include <stdio.h>
#include <stdlib.h>
#include "polinom.h"

//idu sve implementacije

void greska(char *s){
	printf("greska: %s\n");
	exit(EXIT_FAILURE);
}

void unos(int a[], int* n_a){
	printf("Unesite dimenziju polinoma: \n");
	scanf("%d", n_a);
	//obratiti paznju n_a je vec adresa, tako da ne
	//pisemo &n_a, vec samo n_a

	if(*n_a > MAX_POL)
		greska("dimenzija polinoma je veca do dozvoljene");
	
	if(*n_a < 0)
		greska("dimenzija polinoma mora biti pozitivna");
	
	printf("Unesite koeficijente polinoma: \n");
	int i;
	for(i = 0; i < *n_a; i++)
		scanf("%d", &a[i]);
}

void ispis(int a[], int n_a){
	//a0 + a1*x + a2*x^2 + ... + an*x^n
	//ispisujemo prvi clan ako on postoji:
	if(n_a > 0)
		printf("%d", a[0]);
	//ispisujemo drugi clan ako on postoji:
	if(n_a > 1){
		if(a[1] >= 0)
			printf(" + %d*x", a[1]);
		else
			printf(" - %d*x", -a[1]);
	}
	//ispisujemo ostale clanove:
	int i;
	for(i = 2; i < n_a; i++){
		if(a[i] >= 0)
			printf(" + %d*x^%d", a[i], i);
		else
			printf(" - %d*x^%d", -a[i], i);
	}
	printf("\n");
}

int suma(int a[], int n_a, int b[], int n_b, int c[]){
	//obratiti paznju dimenzija polinoma c se
	//vraca kao povratna vrednost funkcije, nije
	//definisana kao argument kao kod funkcije za
	//unos (int* n_a)
	
	int n_c = n_a > n_b ? n_a : n_b;
	//treba da popunimo koeficijente novog pol.
	int i;
	for(i = 0; i < n_c; i++){
		c[i] = 0;
		//ako nismo dosli do kraja polinoma a, dodaj
		//koeficijent iz a
		if(i < n_a)
			c[i] += a[i];
		//ako nismo dosli do kraja polinoma b, dodaj
		//keficijent iz b
		if(i < n_b)
			c[i] += b[i];
	}
	return n_c;
}

int vrednost(int a[], int n_a, int x){
	//prazan polinom
	if(n_a == 0)
		return 0;
	
	//tek sada znamo da poslednji el. postoji!
	int zbir = a[n_a - 1];
	int i;
	for(i = n_a - 2; i >= 0; i--)
		zbir = zbir * x + a[i];
	
	return zbir;
}

void mnozi_skalarom(int a[], int n_a, int s){
	int i;
	for(i = 0; i < n_a; i++)
		a[i] = a[i] * s;
}